Package: FORD
Type: Package
Title: Feature Ordering by Integrated R Square Dependence
Version: 0.1.2
Authors@R: c(
    person(
      "Pouya", "Roudaki",
      email = "roudaki.pouya@gmail.com",
      role = c("aut", "cre")
    ),
    person(
      "Mona", "Azadkia",
      email = "monaazadkia@gmail.com",
      role = c("aut", "ctb")
    )
  )
Description: Feature Ordering by Integrated R square Dependence (FORD) is a variable selection algorithm based on the new measure of dependence: Integrated R2 Dependence Coefficient (IRDC). For more information, see the paper: Azadkia and Roudaki (2025),"A New Measure Of Dependence: Integrated R2" <doi:10.48550/arXiv.2505.18146>.
License: GPL-3
Encoding: UTF-8
URL: https://github.com/PouyaRoudaki/FORD
BugReports: https://github.com/PouyaRoudaki/FORD/issues
RoxygenNote: 7.3.2
Suggests: knitr, rmarkdown, markdown, xfun, testthat, minerva,
        devtools, FOCI, XICOR, KPC, dplyr, ggplot2
VignetteBuilder: knitr
Depends: R (>= 3.6.0), data.table
Imports: RANN, parallel
NeedsCompilation: no
Packaged: 2025-05-28 16:38:48 UTC; rouda
Author: Pouya Roudaki [aut, cre],
  Mona Azadkia [aut, ctb]
Maintainer: Pouya Roudaki <roudaki.pouya@gmail.com>
Repository: CRAN
Date/Publication: 2025-05-30 09:40:12 UTC
Built: R 4.3.3; ; 2025-05-30 11:22:35 UTC; unix

# FORD
[![Latest Version](https://img.shields.io/pypi/v/ford.svg)](https://pypi.python.org/pypi/FORD)
[![Latest homebrew version](https://img.shields.io/homebrew/v/ford.svg?maxAge=2592000)](http://braumeister.org/formula/ford)
[![Latest spack version](https://img.shields.io/spack/v/py-ford)](https://spack.readthedocs.io/en/latest/package_list.html#py-ford)
[![PyPI Total Downloads](https://static.pepy.tech/badge/ford)](https://pepy.tech/project/ford)
[![GitHub license](https://img.shields.io/badge/license-GPL_v3-blue.svg)](./LICENSE)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.1422473.svg)](https://doi.org/10.5281/zenodo.1422473)

This is an automatic documentation generator for modern Fortran programs.
FORD stands for FORtran Documenter. As you may know, "to ford" refers to
crossing a river (or other body of water). It does not, in this context, refer
to any company or individual associated with cars.

Ford was written due to [Doxygen](http://www.doxygen.org/)'s
poor handling of Fortran and the lack of comparable alternatives.
[ROBODoc](https://rfsber.home.xs4all.nl/Robo/index.html) can't actually extract
any information from the source code and just about any other automatic
documentation software I found was either proprietary, didn't work very well
for Fortran, or was limited in terms of how it produced its output.
[f90doc](http://erikdemaine.org/software/f90doc/) is quite good and I managed
to modify it so that it could handle most of Fortran 2003, but it produces
rather ugly documentation, can't provide as many links between different parts
of the documentation as I'd like, and is written in Perl (which I'm not that
familiar with and which lacks the sort of libraries found in Python for
producing HTML content).

The goal of FORD is to be able to reliably produce documentation for modern
Fortran software which is informative and nice to look at. The documentation
should be easy to write and non-obtrusive within the code. While it will never
be as feature-rich as Doxygen, hopefully FORD will be able to provide a good
alternative for documenting Fortran projects.

## Capabilities
Current features include:

- the ability to extract information about variables, procedures, procedure
  arguments, derived types, programs, and modules from the source code.
- the ability to extract documentation from comments in the source code.
- LaTeX support in documentation using [MathJax](https://www.mathjax.org/).
- searchable documentation, using [Tipue Search](http://www.tipue.com/search/).
- author description and social media (including Github!) links.
- links to download the source code.
- links to individual files, both in their raw form or in HTML with syntax
  highlighting.
- use of Markdown to type-set documentation.
- links between related parts of the software.
- Bootstrap CSS for the documentation, making it both functional and pretty.
- configurable settings.
- ability to create a hierarchical set of pages containing general information,
  not associated with any particular part of the source code.
- display an entry for non-Fortran source files with file-level documentation
  and syntax highlighted code.

## Installation

The simplest way to install FORD is using [pip](https://pip.pypa.io/en/latest/):

    pip install ford

Pip will automatically handle all dependencies for you. By default this will
place `ford` in `~/.local/bin` -- you might need to add this to your `PATH`.

Alternatively, FORD is available through the [Homebrew](https://brew.sh) package
manager for Mac OS X. To update Homebrew and install FORD, run these commands in
a terminal:

    brew update
    brew install FORD

If you would like to install the latest development (master) branch from github,
simply add the `--HEAD` flag: `brew install --HEAD FORD`

FORD is also available through the
[spack](https://spack.readthedocs.io/en/latest/) package manager by running the
following command:

    spack install py-ford

## Documentation
More complete documentation can be found in the [docs](https://forddocs.readthedocs.io).

## License
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but **without any warrenty**; without even the implied warranty of
**merchantability** or **fitness for a particular purpose**.  See the
GNU General Public License for more details.

You should have received a [copy](./LICENSE) of the GNU General Public License
along with this program.  If not, see the [GNU website](https://www.gnu.org/licenses/gpl.html).

Documents produced by FORD are derivative works derived from the input used in their production;
they are not affected by this license.

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(FORD)     # Our package
library(FOCI)     # For comparison
library(ggplot2)  # For visualization

## ----continuous---------------------------------------------------------------
n <- 1000
x <- matrix(runif(n * 3), nrow = n)
y <- (x[, 1] + x[, 2]) %% 1

irdc(y, x[, 1])
irdc(y, x[, 2])
irdc(y, x[, 3])

## ----discrete-1---------------------------------------------------------------
n <- 10000
s <- 0.1
x1 <- c(rep(0, n * s), runif(n * (1 - s)))
x2 <- runif(n)
y <- x1

irdc(y, x1, dist.type.X = "discrete")
irdc(y, x2)

## ----discrete-2---------------------------------------------------------------
n <- 10000
x1 <- runif(n)
y1 <- rbinom(n, 1, 0.5)
y2 <- as.numeric(x1 >= 0.5)

irdc(y1, x1, dist.type.X = "discrete")
irdc(y2, x1, dist.type.X = "discrete")

FOCI::codec(y1, x1)
FOCI::codec(y2, x1)

## ----hurdle-vs-gamma----------------------------------------------------------
r_hurdle_poisson <- function(n, p_zero = 0.3, lambda = 2) {
  is_zero <- rbinom(n, 1, p_zero)
  rztpois <- function(m, lambda) {
    samples <- numeric(m)
    for (i in 1:m) {
      repeat {
        x <- rpois(1, lambda)
        if (x > 0) {
          samples[i] <- x
          break
        }
      }
    }
    samples
  }
  result <- numeric(n)
  result[is_zero == 0] <- rztpois(sum(is_zero == 0), lambda)
  result
}

set.seed(123)
n <- 1000
p_zero <- 0.4
lambda <- 10

hurdle <- r_hurdle_poisson(n, p_zero, lambda)
gamma_mix <- c(rep(0, round(p_zero * n)), rgamma(round((1 - p_zero) * n), shape = lambda, rate = 1))

df <- data.frame(
  value = c(hurdle, gamma_mix),
  source = rep(c("Hurdle Poisson", "Gamma Mixture"), each = n)
)

ggplot(df, aes(x = value, fill = source)) +
  geom_histogram(alpha = 0.5, position = "identity", bins = 40) +
  labs(title = "Comparison: Hurdle Poisson vs Gamma Mixture",
       x = "Value", y = "Count", fill = "Distribution") +
  theme_bw()

## ----discrete-3---------------------------------------------------------------
x1 <- sort(gamma_mix)
y1 <- rbinom(n, 1, 0.5)
y2 <- sort(hurdle)

irdc(y1, x1, dist.type.X = "discrete")
irdc(y2, x1, dist.type.X = "discrete")

FOCI::codec(y1, x1)
FOCI::codec(y2, x1)

## ----discrete-4---------------------------------------------------------------
x1 <- sort(hurdle)
y1 <- rbinom(n, 1, 0.5)
y2 <- sort(gamma_mix)

irdc(y1, x1, dist.type.X = "discrete")
irdc(y2, x1, dist.type.X = "discrete")

FOCI::codec(y1, x1)
FOCI::codec(y2, x1)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(minerva)  # For Data
library(FORD)     # Our package
library(XICOR)    # For comparison
library(ggplot2)  # For visualization

## -----------------------------------------------------------------------------
# Load yeast gene expression data
yeast_genes_data <- as.data.frame(Spellman)
gene_names <- colnames(yeast_genes_data)[-1]
time_points <- yeast_genes_data$time
n <- length(time_points)

## -----------------------------------------------------------------------------
xi_vals <- numeric(ncol(yeast_genes_data) - 1)
xi_pvals <- numeric(ncol(yeast_genes_data) - 1)
ird_vals <- numeric(ncol(yeast_genes_data) - 1)
ird_pvals <- numeric(ncol(yeast_genes_data) - 1)

## -----------------------------------------------------------------------------
for (i in 1:(ncol(yeast_genes_data) - 1)) {
  y <- as.numeric(yeast_genes_data[, i + 1])

  # XICOR
  xi_pvals[i] <- xicor(x = time_points , y = y, pvalue = T)$pval
  
  # IRDC
  ird <- irdc_simple(Y = y, X = time_points)
  ird_vals[i] <- ird
  ird_pvals[i] <-  1 - pnorm(ird, mean = 2/n , sd = sqrt((pi^2 / 3 - 3)/n))
}

## -----------------------------------------------------------------------------
xi_fdr <- p.adjust(xi_pvals, method = "BH")
ird_fdr <- p.adjust(ird_pvals, method = "BH")

sig_xi <- gene_names[xi_fdr < 0.05]
sig_ird <- gene_names[ird_fdr < 0.05]
common_genes <- intersect(sig_xi, sig_ird)

cat("All genes:", length(gene_names) , "\n")
cat("XICOR significant genes:", length(sig_xi), "\n")
cat("Simple IRDC significant genes:", length(sig_ird), "\n")
cat("Overlap:", length(common_genes), "\n")
cat("ONLY XICOR significant genes:", length(setdiff(sig_xi, sig_ird)), "\n")
cat("ONLY Simple IRDC significant genes:", length(setdiff(sig_ird, sig_xi)), "\n")

## -----------------------------------------------------------------------------
irdc_detected_only <- setdiff(sig_ird, sig_xi)
irdc_only_fdr <- ird_fdr[match(irdc_detected_only, gene_names)]
top6_idx <- order(irdc_only_fdr)[1:6]
smallest_p_irdc_do <- irdc_detected_only[top6_idx]

irdc_do_genes <- yeast_genes_data[, which(gene_names %in% smallest_p_irdc_do) + 1]
irdc_do_genes <- cbind(time_points, irdc_do_genes)

## ----fig.height=4, fig.width=6, results='asis',message=FALSE------------------
for (i in 1:6) {
  gene_to_plot <- colnames(irdc_do_genes)[i + 1]
  idx <- match(gene_to_plot, gene_names)

  p <- ggplot(irdc_do_genes, aes(x = time_points, y = .data[[gene_to_plot]])) +
    geom_point(size = 3) +
    geom_smooth(method = "loess",se = FALSE, linewidth = 1, color = "blue")+ 
    theme_bw() +
    labs(
      title = paste0("Only Detected by nu: xi adj.p-val = ", round(xi_fdr[idx], 4),
                     ", nu adj.p-val = ", round(ird_fdr[idx], 4)),
      x = "Time Points",
      y = gene_to_plot
    )
  print(p)
}

## -----------------------------------------------------------------------------
xi_irdc_only_fdr <- xi_fdr[match(irdc_detected_only, gene_names)]
top6_diff <- order(-(xi_irdc_only_fdr))[1:6]
largest_p_dif_irdc_do <- irdc_detected_only[top6_diff]

irdc_do_large_diff_genes <- yeast_genes_data[, which(gene_names %in% largest_p_dif_irdc_do) + 1]
irdc_do_large_diff_genes <- cbind(time_points, irdc_do_large_diff_genes)

## ----fig.height=4, fig.width=6, results='asis',message=FALSE------------------
for (i in 1:6) {
  gene_to_plot <- colnames(irdc_do_large_diff_genes)[i + 1]
  idx <- match(gene_to_plot, gene_names)

  p <- ggplot(irdc_do_large_diff_genes, aes(x = time_points, y = .data[[gene_to_plot]])) +
    geom_point(size = 3) +
    geom_smooth(method = "loess", se = FALSE, linewidth = 1, color = "blue")+ 
    theme_bw() +
    labs(
      title = paste0("Only Detected by nu: xi adj.p-val = ", round(xi_fdr[idx], 4),
                     ", nu adj.p-val = ", round(ird_fdr[idx], 4)),
      x = "Time Points",
      y = gene_to_plot
    )
  print(p)
}

module gc_method_fks_h
  use gc_method_h, only : t_method
  implicit none

  public :: t_method_fks, method_fks_constructor
  private

  !> |cmd| `method fks`
  type, extends( t_method ) :: t_method_fks
   contains
     procedure :: init => method_fks_init
     procedure :: run => method_fks_run
     final :: method_fks_destroy
  end type t_method_fks

  interface method_fks_
     module procedure :: method_fks_constructor
  end interface method_fks_

  interface
     module function method_fks_constructor( ptr, nwords, words )result( this )
      class( t_method ), pointer :: this
      class(*),        intent(in) :: ptr
      integer,         intent( in ) :: nwords
      character(*),    intent( in ) :: words(:)
    end function method_fks_constructor

    module function method_fks_init( self )result(ierr)
      class( t_method_fks ), intent( inout ) :: self
      integer :: ierr
    end function method_fks_init

    module function method_fks_run( self )result(ierr)
      class( t_method_fks ), intent( inout ) :: self
      integer :: ierr
    end function method_fks_run

    module subroutine method_fks_destroy( self )
      type( t_method_fks ), intent(inout) :: self
    end subroutine method_fks_destroy
  end interface

CONTAINS

end module gc_method_fks_h

program ford_test_program
!! Simple Fortran program to demonstrate the usage of FORD and to test its installation
use iso_fortran_env, only: output_unit, real64
implicit none
real (real64) :: global_pi = acos(-1)
!! a global variable, initialized to the value of pi
!!
type foo
integer :: foo_stuff
contains
procedure :: do_foo_stuff
end type
type, extends(foo) :: bar
end type
write(output_unit,'(A)') 'Small test program'
call do_stuff(20)
contains
subroutine do_foo_stuff(this)
class(foo) :: this
end subroutine
subroutine do_stuff(repeat)
!! This is documentation for our subroutine that does stuff and things.
!! This text is captured by ford
integer, intent(in) :: repeat
!! The number of times to repeatedly do stuff and things
integer :: i
!! internal loop counter
!!
!!
do i=1,repeat
global_pi = acos(-1)
end do
end subroutine do_stuff
subroutine linalg(A,x,b)
!! Solve Ax = b with linear algebra magic
real, intent(in) :: A(:,:)
!! The a matrix to invert etc.
real, intent(in) :: b(:)
!! The right hand side
real, intent(out) :: x(:)
!! The solution to Ax = b
!!
!! do some stuff, ensure proper bounds etc.
end subroutine linalg
end program ford_test_program

module interfaces
  !! This module demostrates how FORD handles various aspects of
  !! interfaces

  abstract interface
    integer pure function unary_f_t(n)
      !! This defines a named interface for some functions with the
      !! same signature
      implicit none
      integer, intent(in) :: n
      !! Scalar number
    end function unary_f_t
  end interface

  procedure(unary_f_t), pointer, public :: unary_f => null()
  !! This is a procedure pointer with a named interface

  interface generic_unary_f
    !! This is an interface that gives a generic name to multiple
    !! specific (distinguishable) implementations
    procedure unary_f
      !! This is pointer procedure above

    real pure function real_unary_f(x)
      !! A `real` version of our function
      real, intent(in) :: x
    end function real_unary_f

    module procedure :: higher_order_unary_f
      !! A function defined in this module
  end interface generic_unary_f

contains

  pure integer function higher_order_unary_f(f, n)
    !! This is `apply`
    procedure(unary_f_t) :: f
      !! Some function to apply
    integer, intent(in) :: n
      !! Number to call `f` with
    higher_order_unary_f = f(n)
  end function higher_order_unary_f
end module interfaces

module ford_issues
!! ifort /fpp /openmp ford_issues.f90
!!
use ifport
use omp_lib
implicit none
contains
integer function func_with_args(a,                                b,                                c )
integer :: a, b, c
func_with_args = a+b
end function
integer function func_with_bracket()
double precision :: auxf, L_min
auxf = ( 1.0d0 - L_min)
!!    auxf = ( 1.0d0 - L_min)!* (1.0d0 - L_min)
!!
func_with_bracket = 5
end function
!!	integer function func_without_bracket
integer function func_without_bracket()
integer :: omp_p
!!    !$OMP PARALLEL DEFAULT(SHARED) &
!!   & PRIVATE( omp_p )
!!
!!
write(*,*)  'thread ', omp_get_thread_num(), '/', omp_get_num_threads(), ' started'
func_without_bracket = 10
end function
end module ford_issues
program main
use ford_issues
implicit none
integer :: i(3)
i(1) = func_with_args(0,1,0)
i(2) = func_with_bracket()
i(3) = func_without_bracket()
write(*,*) 'ford_issues', i
end program

program ford_test_program
  !! Simple Fortran program to demonstrate the usage of FORD and to test its installation
  use iso_fortran_env, only: output_unit, real64
  implicit none
  real (real64) :: global_pi = acos(-1)
  !! a global variable, initialized to the value of pi

  type foo
    integer :: foo_stuff
  contains
    procedure :: do_foo_stuff
  end type foo

  type, extends(foo) :: bar
  end type bar

  write(output_unit,'(A)') 'Small test program'
  call do_stuff(20)

contains
  subroutine do_foo_stuff(this)
    use test_module, only: increment
    class(foo) :: this
    call increment(this%foo_stuff)
  end subroutine do_foo_stuff

  subroutine do_stuff(repeat)
    !! source: True
    !!
    !! This is documentation for our subroutine that does stuff and things.
    !! This text is captured by ford
    integer, intent(in) :: repeat
    !! The number of times to repeatedly do stuff and things
    integer :: i
    !! internal loop counter

    ! the main content goes here and this is comment is not processed by FORD
    do i=1,repeat
      global_pi = acos(-1)
    end do
  end subroutine do_stuff

  subroutine linalg(A,x,b)
    !! Solve Ax = b with linear algebra magic
    real, intent(in) :: A(:,:)
    !! The a matrix to invert etc.
    real, intent(inout) :: b(:)
    !! The right hand side
    real, intent(out), optional, dimension(:), allocatable :: x
    !! The solution to Ax = b

    ! do some stuff, ensure proper bounds etc.
  end subroutine linalg

  function multidimension_string(n)
    !! Function with a complicated return value
    integer, intent(in) :: n
    !! How big to make the string
    character(kind=kind('a'), len=4), dimension(:, :), allocatable :: multidimension_string
    !! A really complex return type
  end function multidimension_string

end program ford_test_program

module ford_example_type_mod
  !! Summary of this module
  !!
  !! A longer description of the purpose of this module
  implicit none

  private

  type, public :: example_type
    !! Some type that can say hello.
    !!
    !! This type's docs demonstrate how documentation is rendered
    !! differently for public/private components, and for type-bound
    !! procedure bindings and the procedures themselves.
    private
    integer :: counter = 1
    !! Internal counter
    character(len=:), allocatable, public :: name
    !! Name of this instance
    !!
    !! More documentation
  contains
    procedure :: say_hello => example_type_say
    !! This will document the type-bound procedure *binding*, rather
    !! than the procedure itself. The specific procedure docs will be
    !! rendered on the [[example_type]] page.
    !!
    !! This binding has more documentation beyond the summary
    final :: example_type_finalise
    !! This is the finaliser, called when the instance is destroyed.
    !!
    !! This finaliser has more documentation beyond the summary
  end type example_type

  interface example_type
    !! This is a constructor for our type
    !!
    !! This constructor has more documentation that won't appear in
    !! the procedure list, but should appear in the type page
    module procedure make_new_type
  end interface example_type

contains

  subroutine example_type_say(self)
    !! Prints how many times this instance has said hello
    !!
    !! This subroutine has more documentation that won't appear in the
    !! summary in the procedure list, but should appear in the type
    !! page.
    class(example_type), intent(inout) :: self
    write(*, '(a, " has said hello ", i0, " times.")') self%name, self%counter
    self%counter = self%counter + 1
  end subroutine example_type_say

  type(example_type) function make_new_type() result(self)
    !! This is the documentation for the specific constructor
    !!
    !! More documentation
    self%name = "some-default-name"
  end function make_new_type

  subroutine example_type_finalise(self)
    !! Cleans up an [[example_type(type)]] instance
    !!
    !! More documentation
    type(example_type), intent(inout) :: self
    call self%say_hello()
    write(*, '(a, " says goodbye")') self%name
  end subroutine example_type_finalise

end module ford_example_type_mod

! compile wtih
!> ifort /fpp /openmp ford_issues.f90


module ford_issues
#if defined(__GFORTRAN__)

#else
  use ifport
#endif  
  use omp_lib
  
  implicit none

contains


  ! this is function with args that have comments
  integer function func_with_args(a, & 
  &                               b, & ! this is not OK
  &                               c ) 
    integer :: a, b, c
  
    func_with_args = a+b
  end function 


  ! this is OK
  integer function func_with_bracket()
    double precision :: auxf, L_min
    
    ! this is OK  
    auxf = ( 1.0d0 - L_min)
    
    ! this fails  
!  File "e:\nosave\code\gitrepos\ford\ford\reader.py", line 218, in __next__
! raise Exception("Alternate documentation lines can not be inline: {}".format(line))
! Exception: Alternate documentation lines can not be inline:     auxf = ( 1.0d0 - L_min)!* (1.0d0 - L_min)    
    auxf = ( 1.0d0 - L_min)!* (1.0d0 - L_min)
  
    func_with_bracket = 5
  end function 


    ! this fails
!  File "e:\nosave\code\gitrepos\ford\ford\sourceform.py", line 1371, in _initialize
!  for arg in self.SPLIT_RE.split(line.group(3)[1:-1]):
! TypeError: 'NoneType' object is not subscriptable
  integer function func_without_bracket
    integer :: omp_p
    
    ! this also fails
! File "e:\nosave\code\gitrepos\ford\ford\reader.py", line 261, in __next__
! raise Exception("Can not start a new line in Fortran with \"&\": {}".format(line))
! Exception: Can not start a new line in Fortran with "&": & PRIVATE( omp_p )
    !$OMP PARALLEL DEFAULT(SHARED) &
   & PRIVATE( omp_p )

    !$OMP CRITICAL
      write(*,*)  'thread ', omp_get_thread_num(), '/', omp_get_num_threads(), ' started'
    !$OMP END CRITICAL

    !$OMP END PARALLEL
      
    func_without_bracket = 10
  end function 
  
  

end module ford_issues


program main
  use ford_issues
  implicit none
  
  integer :: i(3)
  i(1) = func_with_args(0,1,0)
  i(2) = func_with_bracket()
  i(3) = func_without_bracket()
  write(*,*) 'ford_issues', i
  
end program

c> This is an example of a Fortran-77 program documented in FORD
c>
c> FORD uses the `fixed2free` utility to convert fixed-form source to
c> free-form source, which it can then handle with the same parser
c>
c> This example adapted from a BLAS test program
      PROGRAM FORD77
*> Unit for stdout
      INTEGER          NOUT
      PARAMETER        (NOUT=6)
*> Scalars in Common
      INTEGER          ICASE
      LOGICAL          PASS
* Local Scalars
      REAL             SFAC
* External Subroutines
      EXTERNAL         CHECK1, CHECK2, HEADER
*> Common blocks
      COMMON           /COMBLA/ICASE, N, INCX, INCY, MODE, PASS
* Data statements
      DATA             SFAC/9.765625E-4/

      WRITE (NOUT,99999)
      DO 20 IC = 1, 10
         ICASE = IC
         CALL HEADER
         IF (ICASE.LE.5) THEN
            CALL CHECK2(SFAC)
         ELSE IF (ICASE.GE.6) THEN
            CALL CHECK1(SFAC)
         END IF
   20 CONTINUE
      END

      BLOCK DATA combla
!! Initialise variables in common blocks

      COMMON /COMBLA/ ICASE, N, INCX
!! Some common block
      DATA ICASE /4/
      END

      BLOCK DATA unused
!! A different block data block
      COMMON /UNUSED/ OTHER
!! This common block isn't used anywhere
      DATA OTHER /42/
      END

      SUBROUTINE HEADER
c! You can use the usual FORD docmarks with F77 style comments

*> Parameters
      INTEGER          NOUT
      PARAMETER        (NOUT=6)
*> Scalars in Common
      INTEGER          ICASE
*> Local Arrays
      CHARACTER*6      L(2)
*> Common blocks
      COMMON           /COMBLA/ICASE
      DATA             L(1)/'CDOTC '/
      DATA             L(2)/'CDOTU '/
*Executable Statements
      WRITE (NOUT,99999) ICASE, L(ICASE)
      RETURN
*
99999 FORMAT (/' Test of subprogram number',I3,12X,A6)
*
*     End of HEADER
*
      END
      REAL             FUNCTION SDIFF(SA,SB)
*!    COMPUTES DIFFERENCE OF TWO NUMBERS.  C. L. LAWSON, JPL 1974 FEB 15
      REAL                            SA, SB
      SDIFF = SA - SB
      RETURN
      END

module external_module
  implicit none

  type basis
    integer :: id
  end type basis

  type, extends(basis) :: test
    logical :: ok
  end type


  type, abstract, public :: solverAborts_type
  contains
    procedure(load_aborts), deferred :: load
  end type solverAborts_type


  abstract interface
    !> Loading additional parameters for solver specific abort criteria.
    subroutine load_aborts(self, handle)
      import solverAborts_type
      !> The solver specific type to hold additional abort parameters.
      class(solverAborts_type), intent(inout) :: self
      !> Handle to configuration to load parameters from.
      integer, intent(in) :: handle
    end subroutine load_aborts
  end interface

contains
  subroutine external_sub
  end subroutine external_sub

  !> Fraction to abort at
  real function abort_fraction()
    abort_fraction = 0.15
  end function abort_fraction
  
end module external_module

module gc_method_h

  use gc_pointers_h, only: pointers
  implicit none

  private
  public :: t_method, method_constructor

  type, extends(pointers) :: t_method
   contains
     procedure :: init, run
  end type t_method

  abstract interface
     function method_constructor(ptr, nwords, words) result(this)
       import t_method
       class(t_method), pointer :: this
       class(*), intent(in) :: ptr
       integer, intent(in) :: nwords
       character(*), intent(in) :: words(:)
     end function method_constructor
  end interface

CONTAINS

  function init(self) result(ierr)
    class(t_method), intent(inout) :: self
    integer :: ierr
  end function init

  function run(self) result(ierr)
    class(t_method), intent(inout) :: self
    integer :: ierr
  end function run

end module gc_method_h

module myAbort
  use external_module
  type, public, extends(solverAborts_type) :: vel_abortCriteria_type

    !> Maximal velocity that will be tolerated in the simulation.
    real :: velmax = 0.15

  contains

    procedure :: load => abortCriteria_load

  end type solverAborts_type

contains

  subroutine abortCriteria_load(me, conf)
    use external_module, only: abort_fraction
    ! -------------------------------------------------------------------- !
    !> Object to hold the solver specific configuration parameters.
    class(vel_abortCriteria_type), intent(inout) :: me

    !> Handle to the configuration.
    integer, intent(in) :: conf

    me%velmax = real(conf)*abort_fraction()

  end subroutine mus_abortCriteria_load

end module myAbort

program top_level
  !! This program uses a module from some external source, whose
  !! documentation will be linked to from this documentation
  use external_module
  use remote_module
  use myAbort

  implicit none

  type, extends(test) :: maintest
    character(len=10) :: label
  end type

  call external_sub
  call remote_sub
end program top_level

        program ford_test_program
          !! Simple Fortran program to demonstrate the usage of FORD and to test its installation
          use iso_fortran_env, only: output_unit, real64
          implicit none
          real (real64) :: global_pi = acos(-1)
          !! a global variable, initialized to the value of pi

         type foo
           integer :: foo_stuff
         contains
           procedure :: do_foo_stuff
         end type

         type, extends(foo) :: bar
         end type

         write(output_unit,'(A)') 'Small test program'
         call do_stuff(20)

        contains
          subroutine do_foo_stuff(this)
            class(foo) :: this
          end subroutine

          subroutine do_stuff(repeat)
            !! This is documentation for our subroutine that does stuff and things.
            !! This text is captured by ford
            integer, intent(in) :: repeat
            !! The number of times to repeatedly do stuff and things
            integer :: i
            !! internal loop counter

            ! the main content goes here and this is comment is not processed by FORD
            do i=1,repeat
               global_pi = acos(-1)
            end do
          end subroutine do_stuff

          subroutine linalg(A,x,b)
            !! Solve Ax = b with linear algebra magic
            real, intent(in) :: A(:,:)
            !! The a matrix to invert etc.
            real, intent(in) :: b(:)
            !! The right hand side
            real, intent(out) :: x(:)
            !! The solution to Ax = b

            !! do some stuff, ensure proper bounds etc.
          end subroutine linalg
        end program ford_test_program

module gc_pointers_h
  implicit none

  private
  public :: pointers

  type :: pointers
   contains
    procedure :: check
  end type pointers

  interface pointers
    module procedure pointers_constructor
  end interface pointers

  interface
     module function pointers_constructor( gencat )result( this )
      class(*), pointer, intent( in ) :: gencat
      type( pointers ) :: this
    end function pointers_constructor

    module subroutine check( self )
      class( pointers ), intent( in ) :: self
    end subroutine check
  end interface

 CONTAINS

end module gc_pointers_h

---
title: "ford-demo"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{ford-demo}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(FORD)   
library(FOCI)
```

# Introduction

In this vignette, we demonstrate **FORD** algorithm in [*A New Measure Of Dependence: Integrated R2*](http://arxiv.org/abs/2505.18146), a forward stepwise variable selection algorithm based on the integrated $R^2$ dependence measure. **FORD** is designed for variable ranking in both linear and nonlinear multivariate regression settings.

**FORD** closely follows the structure of **FOCI** [*A Simple Measure Of Conditional Dependence*](https://www.jstor.org/stable/27170947), but replaces the core dependence measure with **irdc**.

---

# Algorithm

Let $Y$ be the response variable and $\mathbf{X} = (X_1, \dots, X_p)$ the predictor variables. Given $n$ i.i.d. samples of $(Y, \mathbf{X})$, FORD proceeds as follows:

1. Select $j_1 = \arg\max_j \nu_n(Y, X_j)$  
   If $\nu_n(Y, X_{j_1}) \leq 0$, return $\hat{V} = \emptyset$

2. Iteratively add the feature that gives the **maximum increase** in irdc:
   $$
   j_{k+1} = \arg\max_{j \notin \{j_1, \ldots, j_k\}} \nu_n(Y, (X_{j_1}, \ldots, X_{j_k}, X_j))
   $$

3. Stop when the irdc does not increase anymore:
   $$
   \nu_n(Y, (X_{j_1}, \ldots, X_{j_k}, X_{j_{k+1}})) \leq \nu_n(Y, (X_{j_1}, \ldots, X_{j_k}))
   $$

If no such $k$ exists, select all variables.

---

# Example 1 — Complex nonlinear function of first 4 features

Here, $Y$ depends only on the first 4 features of $X$ in a nonlinear way.

```{r example-1}
set.seed(42)
n <- 2000
p <- 100
X <- matrix(rnorm(n * p), ncol = p)
colnames(X) <- paste0("X", seq_len(p))
Y <- X[, 1] * X[, 2] + sin(X[, 1] * X[, 3]) + X[, 4]^2
```

## FOCI Result

```{r foci-result1}
result_foci_1 <- foci(Y, X, numCores = 1)
result_foci_1
```

## FORD Result

```{r ford-result1}
result_ford_1 <- ford(Y, X, numCores = 1)
result_ford_1
```

---

# Example 2 — Selecting a fixed number of variables

We can force both FOCI and FORD to select a specific number of variables instead of using an automatic stopping rule.

## FOCI with 5 selected features

```{r foci-result2}
result_foci_2 <- foci(Y, X, num_features = 5, stop = FALSE, numCores = 1)
result_foci_2
```

## FORD with 5 selected features

```{r ford-result2}
result_ford_2 <- ford(Y, X, num_features = 5, stop = FALSE, numCores = 1)
result_ford_2
```

---

# Conclusion

**FORD** provides an interpretable, irdc-based alternative to FOCI for variable selection in regression tasks. It offers a principled forward selection framework that can detect complex nonlinear relationships and be adapted for fixed-size feature subsets.

For further theoretical details, see our paper:  
Azadkia and Roudaki (2025), [*A New Measure Of Dependence: Integrated R2*](http://arxiv.org/abs/2505.18146)

---
title: "irdc-demo"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{irdc-demo}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(FORD)     # Our package
library(FOCI)     # For comparison
library(ggplot2)  # For visualization
```

# Introduction

We propose a new dependence measure $\nu(Y, \mathbf{X})$ ([*A New Measure Of Dependence: Integrated R2*](http://arxiv.org/abs/2505.18146)) to assess how much a random vector $\mathbf{X}$ explains a univariate response $Y$. Let $Y$ be a random variable and $\mathbf{X} = (X_1, \cdots, X_p)$ a random vector defined on the same probability space. Let $\mu$ be the probability law of $Y$, and $S$ be the support of $\mu$. Define:

$$
\tilde{S} = 
\begin{cases}
S \setminus \{s_{\max}\} & \text{if } S \text{ has a maximum } s_{\max} \\
S & \text{otherwise}
\end{cases}
$$

We define the measure $\tilde{\mu}$ on $S$ as:

$$
\tilde{\mu}(A) = \frac{\mu(A \cap \tilde{S})}{\mu(\tilde{S})}, \quad \text{for measurable } A \subseteq S
$$

Then the **irdc dependence coefficient** is defined as:

$$
\nu(Y, \mathbf{X}) := \int \frac{\mathrm{Var}(\mathbb{E}[\mathbf{1}\{Y > t\} \mid \mathbf{X}])}{\mathrm{Var}(\mathbf{1}\{Y > t\})} d\tilde{\mu}(t)
$$

In contrast, [*A Simple Measure Of Conditional Dependence*](https://www.jstor.org/stable/27170947) consider:

$$
T(Y, \mathbf{X}) = \frac{\int \mathrm{Var}(\mathbb{E}[\mathbf{1}\{Y \ge t\} \mid \mathbf{X}]) d\mu(t)}{\int \mathrm{Var}(\mathbf{1}\{Y \ge t\}) d\mu(t)}
$$

# Continuous Case

```{r continuous}
n <- 1000
x <- matrix(runif(n * 3), nrow = n)
y <- (x[, 1] + x[, 2]) %% 1

irdc(y, x[, 1])
irdc(y, x[, 2])
irdc(y, x[, 3])
```

# Discrete Case

## Example 1

```{r discrete-1}
n <- 10000
s <- 0.1
x1 <- c(rep(0, n * s), runif(n * (1 - s)))
x2 <- runif(n)
y <- x1

irdc(y, x1, dist.type.X = "discrete")
irdc(y, x2)
```

## Example 2

```{r discrete-2}
n <- 10000
x1 <- runif(n)
y1 <- rbinom(n, 1, 0.5)
y2 <- as.numeric(x1 >= 0.5)

irdc(y1, x1, dist.type.X = "discrete")
irdc(y2, x1, dist.type.X = "discrete")

FOCI::codec(y1, x1)
FOCI::codec(y2, x1)
```

## Example 3: Hurdle vs Gamma Mixture

```{r hurdle-vs-gamma}
r_hurdle_poisson <- function(n, p_zero = 0.3, lambda = 2) {
  is_zero <- rbinom(n, 1, p_zero)
  rztpois <- function(m, lambda) {
    samples <- numeric(m)
    for (i in 1:m) {
      repeat {
        x <- rpois(1, lambda)
        if (x > 0) {
          samples[i] <- x
          break
        }
      }
    }
    samples
  }
  result <- numeric(n)
  result[is_zero == 0] <- rztpois(sum(is_zero == 0), lambda)
  result
}

set.seed(123)
n <- 1000
p_zero <- 0.4
lambda <- 10

hurdle <- r_hurdle_poisson(n, p_zero, lambda)
gamma_mix <- c(rep(0, round(p_zero * n)), rgamma(round((1 - p_zero) * n), shape = lambda, rate = 1))

df <- data.frame(
  value = c(hurdle, gamma_mix),
  source = rep(c("Hurdle Poisson", "Gamma Mixture"), each = n)
)

ggplot(df, aes(x = value, fill = source)) +
  geom_histogram(alpha = 0.5, position = "identity", bins = 40) +
  labs(title = "Comparison: Hurdle Poisson vs Gamma Mixture",
       x = "Value", y = "Count", fill = "Distribution") +
  theme_bw()
```

## Example 3 Continued

```{r discrete-3}
x1 <- sort(gamma_mix)
y1 <- rbinom(n, 1, 0.5)
y2 <- sort(hurdle)

irdc(y1, x1, dist.type.X = "discrete")
irdc(y2, x1, dist.type.X = "discrete")

FOCI::codec(y1, x1)
FOCI::codec(y2, x1)
```

## Example 4

```{r discrete-4}
x1 <- sort(hurdle)
y1 <- rbinom(n, 1, 0.5)
y2 <- sort(gamma_mix)

irdc(y1, x1, dist.type.X = "discrete")
irdc(y2, x1, dist.type.X = "discrete")

FOCI::codec(y1, x1)
FOCI::codec(y2, x1)
```

# Conclusion

*irdc* provides a flexible and theoretically grounded dependence measure that works for both continuous and discrete predictors. 

For further theoretical details, see our paper:  
Azadkia and Roudaki (2025), [*A New Measure Of Dependence: Integrated R2*](http://arxiv.org/abs/2505.18146)

---
title: "independence-test"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{indep-test}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(minerva)  # For Data
library(FORD)     # Our package
library(XICOR)    # For comparison
library(ggplot2)  # For visualization
```

# Introduction

We propose a simple dependence measure $\nu(Y, \mathbf{X})$ ([*A New Measure Of Dependence: Integrated R2*](http://arxiv.org/abs/2505.18146).) to assess how much a random variable $X$ explains a univariate response $Y$.



Then the **simple irdc dependence measure** is defined as:

$$
    \nu_{n}^{\text{1-dim}}(Y, X) := 1 - \frac{1}{2}\sum_{j \atop r_j \neq 1, n}\sum_{i\neq j, j - 1, n} \frac{\mathbb{I}[r_j\in\mathcal{K}_i]}{(r_j - 1)(n - r_j)}.
$$
where $\mathbb{I}[r_j\in\mathcal{K}_i]$ is a 0-1 indicator function and $\mathcal{K}_i := [\min\{r_i, r_{i + 1}\}, \max\{r_{i}, r_{i + 1}\}]$ when we ordered data with respect to $X$ and rank with respect to $Y$.  In [*A New Measure Of Dependence: Integrated R2*](http://arxiv.org/abs/2505.18146), we conjecture that under the same assumptions $$\sqrt{n}\left(\nu_{n}^{\text{1-dim}}(Y, X)-\frac{2}{n}\right)$$
converges in distribution to $N(0, \pi^2/3 - 3)$ as $n\rightarrow\infty$.

We compare this metric with the ([*A new coefficient of correlation*, Chatterjee 2021](https://www.tandfonline.com/doi/full/10.1080/01621459.2020.1758115).
The $\xi$ measure is defined as following:
$$
\xi_n(X, Y) := 1 - \frac{3 \sum_{i=1}^{n-1} |r_{i+1} - r_i|}{n^2 - 1}.
$$
where we ordered data with respect to $X$ and rank with respect to $Y$.

([Chatterjee 2021](https://www.tandfonline.com/doi/full/10.1080/01621459.2020.1758115)
showed that given $X$ and $Y$ are independent and $Y$ is continuous. Then
$$
\sqrt{n} \, \xi_n(X, Y) \xrightarrow{d} \mathcal{N}(0, 2/5) \quad \text{in distribution as } n \to \infty.
$$

# Pattern detection for Yeast genes

In this study, we use the revised and curated dataset, `Spellman` in `R` package`minerva`, with 4381 genes to study the power of $\nu_{n}^{\text{1-dim}}(Y, X)$ in discovering genes with oscillating transcript levels, and compare its performance with the competing
tests by $\xi_n$. We also explore the possible patterns in this dataset.

### Load and Prepare Data

```{r}
# Load yeast gene expression data
yeast_genes_data <- as.data.frame(Spellman)
gene_names <- colnames(yeast_genes_data)[-1]
time_points <- yeast_genes_data$time
n <- length(time_points)
```

### Initialize Results Storage

```{r}
xi_vals <- numeric(ncol(yeast_genes_data) - 1)
xi_pvals <- numeric(ncol(yeast_genes_data) - 1)
ird_vals <- numeric(ncol(yeast_genes_data) - 1)
ird_pvals <- numeric(ncol(yeast_genes_data) - 1)
```

### Run Dependence Measures for Each Gene

```{r}
for (i in 1:(ncol(yeast_genes_data) - 1)) {
  y <- as.numeric(yeast_genes_data[, i + 1])

  # XICOR
  xi_pvals[i] <- xicor(x = time_points , y = y, pvalue = T)$pval
  
  # IRDC
  ird <- irdc_simple(Y = y, X = time_points)
  ird_vals[i] <- ird
  ird_pvals[i] <-  1 - pnorm(ird, mean = 2/n , sd = sqrt((pi^2 / 3 - 3)/n))
}
```

### Adjust p-values and Identify Significant Genes

```{r}
xi_fdr <- p.adjust(xi_pvals, method = "BH")
ird_fdr <- p.adjust(ird_pvals, method = "BH")

sig_xi <- gene_names[xi_fdr < 0.05]
sig_ird <- gene_names[ird_fdr < 0.05]
common_genes <- intersect(sig_xi, sig_ird)

cat("All genes:", length(gene_names) , "\n")
cat("XICOR significant genes:", length(sig_xi), "\n")
cat("Simple IRDC significant genes:", length(sig_ird), "\n")
cat("Overlap:", length(common_genes), "\n")
cat("ONLY XICOR significant genes:", length(setdiff(sig_xi, sig_ird)), "\n")
cat("ONLY Simple IRDC significant genes:", length(setdiff(sig_ird, sig_xi)), "\n")
```
## Genes Only Detected by IRDC

```{r}
irdc_detected_only <- setdiff(sig_ird, sig_xi)
irdc_only_fdr <- ird_fdr[match(irdc_detected_only, gene_names)]
top6_idx <- order(irdc_only_fdr)[1:6]
smallest_p_irdc_do <- irdc_detected_only[top6_idx]

irdc_do_genes <- yeast_genes_data[, which(gene_names %in% smallest_p_irdc_do) + 1]
irdc_do_genes <- cbind(time_points, irdc_do_genes)
```

### Plot Top Genes Only Detected by IRDC With Smallest Adjusted P_value IRDC

```{r, fig.height=4, fig.width=6, results='asis',message=FALSE}
for (i in 1:6) {
  gene_to_plot <- colnames(irdc_do_genes)[i + 1]
  idx <- match(gene_to_plot, gene_names)

  p <- ggplot(irdc_do_genes, aes(x = time_points, y = .data[[gene_to_plot]])) +
    geom_point(size = 3) +
    geom_smooth(method = "loess",se = FALSE, linewidth = 1, color = "blue")+ 
    theme_bw() +
    labs(
      title = paste0("Only Detected by nu: xi adj.p-val = ", round(xi_fdr[idx], 4),
                     ", nu adj.p-val = ", round(ird_fdr[idx], 4)),
      x = "Time Points",
      y = gene_to_plot
    )
  print(p)
}
```

### Genes with Largest Adjusted P_value of XICOR

```{r}
xi_irdc_only_fdr <- xi_fdr[match(irdc_detected_only, gene_names)]
top6_diff <- order(-(xi_irdc_only_fdr))[1:6]
largest_p_dif_irdc_do <- irdc_detected_only[top6_diff]

irdc_do_large_diff_genes <- yeast_genes_data[, which(gene_names %in% largest_p_dif_irdc_do) + 1]
irdc_do_large_diff_genes <- cbind(time_points, irdc_do_large_diff_genes)
```

### Plot Top Genes with With Largest Adjusted P_value XICOR

```{r, fig.height=4, fig.width=6, results='asis',message=FALSE}
for (i in 1:6) {
  gene_to_plot <- colnames(irdc_do_large_diff_genes)[i + 1]
  idx <- match(gene_to_plot, gene_names)

  p <- ggplot(irdc_do_large_diff_genes, aes(x = time_points, y = .data[[gene_to_plot]])) +
    geom_point(size = 3) +
    geom_smooth(method = "loess", se = FALSE, linewidth = 1, color = "blue")+ 
    theme_bw() +
    labs(
      title = paste0("Only Detected by nu: xi adj.p-val = ", round(xi_fdr[idx], 4),
                     ", nu adj.p-val = ", round(ird_fdr[idx], 4)),
      x = "Time Points",
      y = gene_to_plot
    )
  print(p)
}
```

---
project: Example Project
src_dir: ./src
output_dir: ./doc
project_github: https://github.com/cmacmackin/futility
project_website: https://github.com
summary: Some Fortran program which I wrote.
author: John Doe
author_description: I program stuff in Fortran.
github: https://github.com/cmacmackin
email: john.doe@example.com
fpp_extensions: fpp
preprocess: true
macro: HAS_DECREMENT
predocmark: >
docmark_alt: #
predocmark_alt: <
display: public
         protected
source: false
graph: true
search: true
extra_mods: json_module: http://jacobwilliams.github.io/json-fortran/
            futility: http://cmacmackin.github.io
            iso_fortran_env: "https://gcc.gnu.org/onlinedocs/gfortran/ISO_005fFORTRAN_005fENV.html"
license: by-nc
extra_filetypes: sh #
max_frontpage_items: 4
exclude: excluded_file.f90
exclude_dir: src/excluded_directory
---

Hi, my name is ${USER}.

This is a project which I wrote. This file will provide the documents. I'm
writing the body of the text here. It contains an overall description of the
project. It might explain how to go about installing/compiling it. It might
provide a change-log for the code. [[linalg]] Maybe it will talk about the
history and/or motivation for this software.

@Note
You can include any notes (or bugs, warnings, or todos) like so.

@Bug
You can have multi-paragraph versions of these too! That means you can
include

- ordered lists
- unordered lists
- images
- etc.

Isn't that cool?
@endbug

@Bug Hey I'm doing it again...

This ones ends mid...@endbug ...paragraph.

You can have as many paragraphs as you like here and can use headlines, links,
images, etc. Basically, you can use anything in Markdown and Markdown-Extra.
Furthermore, you can insert LaTeX into your documentation. So, for example,
you can provide inline math using like \( y = x^2 \) or math on its own line
like \[ x = \sqrt{y} \] or $$ e = mc^2. $$ You can even use LaTeX environments!
So you can get numbered equations like this:
\begin{equation}
  PV = nRT
\end{equation}
So let your imagination run wild. As you can tell, I'm more or less just
filling in space now. This will be the last sentence.

title: Notes
author: Jane Bloggs
copy_subdir: ../images
ordered_subpage: subpage2.md
ordered_subpage: subpage1.md
---

You can also add additional documentation as static pages by
specifying `page_dir` in your project file. See [the documentation on
static pages][1] for more details.

This image has been included by copying a whole directory, using
`copy_subdir: ../images`:

![Fortran Logo](../images/Fortran_logo.svg)

This directory has subpages, including some where the ordering is
specified using `ordered_subpage`. The [static pages docs][1] have more information on how
this works.

[1]: https://forddocs.readthedocs.io/en/latest/user_guide/writing_pages.html

title: Subpage in subdirectory
---

This page is deeper in the hierarchy. You can use `|page|` in URLs to
link to other places in the page hierarchy, [such as this other
subpage](|page|/subpage1.html)

You can link to the API documentation with the Ford `[[link]]` style:
[[ford_test_program]]
